#include <stdio.h>
#include <math.h>
#include <limits.h>


int  brandLast     [1000001];
int  standLastCnt  [1000001];
int  sortedBrandsBr[1000000]; /* by first occurence */
int  sortedBrandsSt[1000000]; /* by first occurence */
int  sortedBrandsCnt;
int  intervalBegin;
int  minIntervalBegin, minIntervalEnd;
int  minSamples;
int  standSamples  [1000001]; /* prefix sums */

int main() {
	int N; /* stands */
	int K; /* brands */
	while (scanf("%d %d\n", &N, &K) == 2) {
		int i,s;
		for (i = 1; i<=K; i++) {
			brandLast[i] = 0;
		}
		sortedBrandsCnt = 0;
		intervalBegin = 1;
		minSamples = INT_MAX;
		standSamples[0] = 0;

		for (s = 1; s <= N; s++) {    /* reading test case */
			standLastCnt[s] = 0;
			int L;
			scanf("%d ", &L);
			standSamples[s] = L;
			standSamples[s] += standSamples[s-1];
			for (i = 0; i<L; i++) {     /* reading stand */
				int b;
				scanf("%d ", &b);
				if (brandLast[b]) {
					standLastCnt[brandLast[b]]--;
				} else {
					sortedBrandsBr[sortedBrandsCnt] = b;
					sortedBrandsSt[sortedBrandsCnt] = s;
					sortedBrandsCnt++;
				}
				brandLast[b] = s;
				standLastCnt[s]++;
			}
			if (sortedBrandsCnt >= K) {
				while ((standLastCnt[intervalBegin] == 0) && (intervalBegin<s)) {
					intervalBegin++;
				}
				int samples = standSamples[s] - standSamples[intervalBegin-1];
				if (samples < minSamples) {
					minSamples = samples;
					minIntervalBegin = intervalBegin;
					minIntervalEnd = s;
				}
			}
		}
		if (sortedBrandsCnt >= K) { /* solution exists */
			s=0;
			for (i=0; i<sortedBrandsCnt; i++) {
				standLastCnt[brandLast[sortedBrandsBr[i]]]--;
				s = sortedBrandsSt[i];
				while ((standLastCnt[intervalBegin] == 0) && (intervalBegin<N)) {
					intervalBegin++;
				}
				int samples = standSamples[s] + standSamples[N] - standSamples[intervalBegin-1];
				if (samples < minSamples) {
					minSamples = samples;
					minIntervalBegin = intervalBegin;
					minIntervalEnd = s;
				}
			}

			/*printf("%d -- %d\n", minIntervalBegin, minIntervalEnd); /* XXX */
			int samples = 0;
			if (minIntervalBegin <= minIntervalEnd) {
				samples = standSamples[minIntervalEnd] - standSamples[minIntervalBegin-1];
			} else {
				samples = standSamples[minIntervalEnd] + standSamples[N] - standSamples[minIntervalBegin-1];
			}
			printf("%d\n", samples);
		} else {
			printf("-1\n");
		}
	}

	return 0;
}
