#include <stdio.h>
#include <math.h>

#define MAX_N 100000
struct L {
	int diag;
	long long int cnt;
	struct L *next;
};
struct L ls[2*MAX_N];
int lsUsed;

struct L *hash[2*MAX_N];
int hashMod;
#define hash(direction,diag) hash[direction*MAX_N + ((unsigned)diag)%hashMod];

void pushL (int direction, int diag) {
	struct L **lp = &hash(direction, diag);
	struct L *l = *lp;
	while (l && (l->diag != diag) && l->next) {
		l = l->next;
	}
	if (!l) {
		l = *lp = ls + lsUsed++;
		l->diag = diag;
		l->cnt = 0;
		l->next = NULL;
	} else
	if (l->diag != diag) {
		l->next = ls + lsUsed++;
		l = l->next;
		l->diag = diag;
		l->cnt = 0;
		l->next = NULL;
	}
	l->cnt++;
}

int main() {
	long long int N;
	while (scanf("%d\n", &N) == 1) {
		int i;
		hashMod = (1<<(int)floor(log(N))) - 1;
		if (hashMod < 7) hashMod=7;
		if (hashMod > MAX_N-1) hashMod=MAX_N-1;
		for (i=0; i<hashMod; i++) {
			hash[i] = hash[i+MAX_N] = NULL;
		}
		lsUsed = 0;
		for (i=0; i<N; i++) {
			int x,y;
			scanf("%d %d\n", &x, &y);
			pushL(0, x+y);
			pushL(1, x-y);
		}
		long long int cnt = 0;
		for (i=0; i<hashMod; i++) {
			struct L *l = hash[i];
			while (l) {
				cnt += (l->cnt * (l->cnt-1));
				l=l->next;
			}
			l = hash[i+MAX_N];
			while (l) {
				cnt += (l->cnt * (l->cnt-1));
				l=l->next;
			}
		}
		printf("%lf\n", (double)cnt / (N*N));
	}

	return 0;
}
